package pogoda;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.SpringLayout;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JTextField;
import javax.swing.JSpinner;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.util.Optional;
import java.awt.event.ActionEvent;

public class OknoPogodowe {
	private PobieraczkaPogody pobieraczka = new PobieraczkaPogody();
	private JFrame frame;
	private JTextField txtMiasto;
	private JSpinner spinner_Lon;
	private JSpinner spinner_Lat;
	private JLabel lblT;
	private JLabel lblW;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					OknoPogodowe window = new OknoPogodowe();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public OknoPogodowe() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 800, 480);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		SpringLayout springLayout = new SpringLayout();
		frame.getContentPane().setLayout(springLayout);
		
		JLabel lblPodajMiasto = new JLabel("Podaj miasto:");
		lblPodajMiasto.setFont(new Font("Dialog", Font.BOLD, 18));
		springLayout.putConstraint(SpringLayout.NORTH, lblPodajMiasto, 10, SpringLayout.NORTH, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.WEST, lblPodajMiasto, 10, SpringLayout.WEST, frame.getContentPane());
		frame.getContentPane().add(lblPodajMiasto);
		
		JLabel lblDugoGeo = new JLabel("Długość geo:");
		lblDugoGeo.setFont(new Font("Dialog", Font.BOLD, 18));
		springLayout.putConstraint(SpringLayout.NORTH, lblDugoGeo, 31, SpringLayout.SOUTH, lblPodajMiasto);
		springLayout.putConstraint(SpringLayout.WEST, lblDugoGeo, 0, SpringLayout.WEST, lblPodajMiasto);
		frame.getContentPane().add(lblDugoGeo);
		
		JLabel lblSzerokoGeo = new JLabel("Szerokość geo:");
		lblSzerokoGeo.setFont(new Font("Dialog", Font.BOLD, 18));
		springLayout.putConstraint(SpringLayout.NORTH, lblSzerokoGeo, 0, SpringLayout.NORTH, lblDugoGeo);
		springLayout.putConstraint(SpringLayout.WEST, lblSzerokoGeo, 239, SpringLayout.EAST, lblDugoGeo);
		frame.getContentPane().add(lblSzerokoGeo);
		
		JLabel lblTemperatura = new JLabel("Temperatura:");
		springLayout.putConstraint(SpringLayout.WEST, lblTemperatura, 10, SpringLayout.WEST, frame.getContentPane());
		lblTemperatura.setFont(new Font("Dialog", Font.BOLD, 18));
		frame.getContentPane().add(lblTemperatura);
		
		JLabel lblWiatr = new JLabel("Wiatr:");
		springLayout.putConstraint(SpringLayout.WEST, lblWiatr, 10, SpringLayout.WEST, frame.getContentPane());
		lblWiatr.setFont(new Font("Dialog", Font.BOLD, 18));
		springLayout.putConstraint(SpringLayout.NORTH, lblWiatr, 39, SpringLayout.SOUTH, lblTemperatura);
		frame.getContentPane().add(lblWiatr);
		
		txtMiasto = new JTextField();
		txtMiasto.setText("miasto");
		springLayout.putConstraint(SpringLayout.NORTH, txtMiasto, 6, SpringLayout.SOUTH, lblPodajMiasto);
		springLayout.putConstraint(SpringLayout.WEST, txtMiasto, 67, SpringLayout.WEST, frame.getContentPane());
		frame.getContentPane().add(txtMiasto);
		txtMiasto.setColumns(10);
		
		spinner_Lon = new JSpinner();
		springLayout.putConstraint(SpringLayout.NORTH, lblTemperatura, 106, SpringLayout.SOUTH, spinner_Lon);
		springLayout.putConstraint(SpringLayout.NORTH, spinner_Lon, 9, SpringLayout.SOUTH, lblDugoGeo);
		springLayout.putConstraint(SpringLayout.WEST, spinner_Lon, 67, SpringLayout.WEST, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.EAST, spinner_Lon, 2, SpringLayout.EAST, txtMiasto);
		frame.getContentPane().add(spinner_Lon);
		
		spinner_Lat = new JSpinner();
		springLayout.putConstraint(SpringLayout.NORTH, spinner_Lat, 6, SpringLayout.SOUTH, lblSzerokoGeo);
		springLayout.putConstraint(SpringLayout.WEST, spinner_Lat, -362, SpringLayout.EAST, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.EAST, spinner_Lat, -220, SpringLayout.EAST, frame.getContentPane());
		frame.getContentPane().add(spinner_Lat);
		
		lblT = new JLabel("T");
		springLayout.putConstraint(SpringLayout.WEST, lblT, 20, SpringLayout.EAST, lblTemperatura);
		springLayout.putConstraint(SpringLayout.SOUTH, lblT, 36, SpringLayout.SOUTH, lblTemperatura);
		springLayout.putConstraint(SpringLayout.EAST, lblT, 366, SpringLayout.WEST, frame.getContentPane());
		frame.getContentPane().add(lblT);
		
		lblW = new JLabel("W");
		springLayout.putConstraint(SpringLayout.NORTH, lblW, -25, SpringLayout.SOUTH, lblT);
		springLayout.putConstraint(SpringLayout.WEST, lblW, 88, SpringLayout.WEST, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.SOUTH, lblW, -200, SpringLayout.SOUTH, frame.getContentPane());
		frame.getContentPane().add(lblW);
		
		JButton btnNewButton = new JButton("Pobierz dla miasta");
		springLayout.putConstraint(SpringLayout.NORTH, btnNewButton, 10, SpringLayout.NORTH, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.WEST, btnNewButton, 67, SpringLayout.EAST, txtMiasto);
		springLayout.putConstraint(SpringLayout.SOUTH, btnNewButton, 50, SpringLayout.NORTH, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.EAST, btnNewButton, 209, SpringLayout.EAST, txtMiasto);
		frame.getContentPane().add(btnNewButton);
		
		JButton btnPobierzDlaWsprzdnych = new JButton("Pobierz dla współrzędnych");
		btnPobierzDlaWsprzdnych.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				pobierzDlaWspolrzednych();
			}
		});
		springLayout.putConstraint(SpringLayout.EAST, lblW, 12, SpringLayout.EAST, btnPobierzDlaWsprzdnych);
		springLayout.putConstraint(SpringLayout.NORTH, lblT, 34, SpringLayout.SOUTH, btnPobierzDlaWsprzdnych);
		springLayout.putConstraint(SpringLayout.WEST, btnPobierzDlaWsprzdnych, 98, SpringLayout.WEST, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.EAST, btnPobierzDlaWsprzdnych, -485, SpringLayout.EAST, frame.getContentPane());
		springLayout.putConstraint(SpringLayout.NORTH, btnPobierzDlaWsprzdnych, -72, SpringLayout.NORTH, lblTemperatura);
		springLayout.putConstraint(SpringLayout.SOUTH, btnPobierzDlaWsprzdnych, -32, SpringLayout.NORTH, lblTemperatura);
		frame.getContentPane().add(btnPobierzDlaWsprzdnych);
	}

	private void pobierzDlaWspolrzednych() {
		double longitude = ((Number)spinner_Lon.getValue()).doubleValue();
		double latitude = ((Number)spinner_Lat.getValue()).doubleValue();
		
		Optional<Pogoda> wynik = pobieraczka.pobierzAktualnaPogode(latitude, longitude);
		if(wynik.isPresent()) {
			Pogoda pogoda = wynik.get();
			uaktualnijOkno(pogoda);
		}
	}
	// porządniej byłoby zrobić pobieranie w tle za pomocą SwingWorker
	

	private void uaktualnijOkno(Pogoda pogoda) {
		lblT.setText(pogoda.temperature() + " ˚C");
		lblW.setText(pogoda.windspeed() + " km/h");
	}
}
